#pragma once

#include <atlstr.h>

class Registry
{
public:
	static BOOL DeleteKey( HKEY main_key, const TCHAR *key_name )
	{
		return ( ERROR_SUCCESS == RegDeleteKeyEx( main_key, key_name, KEY_ALL_ACCESS, 0 ) );
	}

	static BOOL DeleteValue( HKEY main_key, const TCHAR *key_name, const TCHAR *value_name ) 
	{
		HKEY hKey; 
		if( ERROR_SUCCESS != RegOpenKeyEx(main_key, key_name, 0, KEY_ALL_ACCESS, &hKey) )
		{
			return FALSE;
		}

		if( ERROR_SUCCESS != RegDeleteValue(hKey, value_name) )
		{
			RegCloseKey(hKey);
			return FALSE;
		}

		RegCloseKey(hKey);
		return TRUE;
	}

	static CString ReadString( HKEY main_key, const TCHAR *key_name, const TCHAR *value_name )
	{
		HKEY hKey; 
		if( ERROR_SUCCESS != RegOpenKeyEx(main_key, key_name, 0, KEY_READ, &hKey) )
		{
			return _T("");
		}

		DWORD dwType;
		DWORD size = 4096;
		TCHAR data[4096];

		if( ERROR_SUCCESS != RegQueryValueEx( hKey, value_name, 0, &dwType, (BYTE *)data, &size ) )
		{
			RegCloseKey(hKey);
			return _T("");
		}

		RegCloseKey(hKey);
		return data;
	}

	static BOOL WriteString( HKEY main_key, const TCHAR *key_name, const TCHAR *value_name, const TCHAR *value )
	{
		HKEY hKey; 
		if( ERROR_SUCCESS != RegOpenKeyEx(main_key, key_name, 0, KEY_ALL_ACCESS, &hKey) )
		{
			// [:2008-12-03]  ʴ  Ű .
			if (ERROR_SUCCESS != RegCreateKey(main_key, key_name,  &hKey))
				return FALSE;
		}

		if( ERROR_SUCCESS != RegSetValueEx( hKey, value_name, 0, REG_SZ, (const BYTE *)(const char *)value, lstrlen(value)*2+1 ) )
		{
			RegCloseKey(hKey);
			return FALSE;
		}

		RegCloseKey(hKey);
		return TRUE;
	}
};